#pragma once

#include <vector>
#include <list>
#include <map>

#define M_PI 3.1415926
#define LOCUS_WIDTH				1024
#define LOCUS_HEIGHT			1024
#define IVS_VIDEO_WIDTH			8192
#define IVS_VIDEO_HEIGHT		8192

#define Min_Distance			512		//ͷС2루8192ϵ£
#define  MAX_TRACKPOINT_NUM 10
#define IVS_INFO_SHOW_FRAMES	100		// ڶ֡ʾܷϢ(˶켣,Ϣ)
#define MAX_IVS_LOCUS_SEG_CNT	50		// ˶Ŀ˶켣Ŀ
#define MAX_IVS_OBJECT_CNT		50		// ˶ĿĿ
#define CHANNEL_MAX_COUNT		32

enum
{
	Color_ObjectNormal = RGB(0,255,0),	// Ŀɫ
		Color_ObjectAlarm  = RGB(255,0,0),	// ʱĿɫ
		Color_LocusNormal  = RGB(0,255,0),	// 켣ɫ
		Color_LocusAlarm   = RGB(255,0,0),	// ʱ켣ɫ
		Color_RuleNormal   = RGB(0,0,255),	// ɫ
		Color_RuleAlarm    = RGB(255,0,0)	// ʱɫ
};

enum IvsOjbOpt
{
	IvsOjbOpt_AddOjb = 1,
		IvsOjbOpt_AddLocus,
		IvsOjbOpt_DelOjb,
		IvsOjbOpt_HideLocus
};

typedef struct _tagCHANNEL_INFO
{
	bool			m_bAtmIvs;
	bool			m_bSupportIvs;
	bool			m_bEnableIvs;
	int				m_nMaxRuleStructSize;
	int				m_nMaxRuleNum;
}CHANNEL_INFO;

typedef struct _deviceinfo_tag
{
public:	
	LLONG			m_ID;									//豸ID
	LLONG			m_LoginHandle;							//½
	int				m_ChannelCount;							//ͨ
	CHANNEL_INFO	m_Channel[CHANNEL_MAX_COUNT];			//ͨϢ
}DEV_INFO;

//RECT=(X-XSize, Y-YSize, X+XSize, Y+YSize)
typedef struct _PRIVATE_IVS_POINT
{
	short			x;
	short			y;
	short			xSize;
	short			ySize;
}PRIVATE_IVS_POINT;

//˶Ŀ켣
typedef struct _PRIVATE_IVS_OBJ
{
	int				decode_id;
	int				obj_id;
	int				enable;
	PRIVATE_IVS_POINT	track_point[MAX_TRACKPOINT_NUM];
	int				trackpt_num;
	int				operator_type; //Ϊࣺ(1), 켣(2)ɾ(3)켣(4),ֵЧ
	int				frame_part_id; //0ʾһ֡Ŀʼε
	char			reserved[128]; //
	
}PRIVATE_IVS_OBJ;

struct IvsRuleInfo
{
	char szRuleName[MAX_NAME_LEN];				// ,ͬ
	bool bRuleEnable;							// ʹ
	
	CFG_RULE_INFO stuRuleInfo;
	
	union RuleEvent
	{
		CFG_CROSSLINE_INFO			stuCrossLineCfg;		// ߹,Ϊ"CrossLineDetection"ʱЧ
		CFG_CROSSREGION_INFO		stuCrossRegionCfg;		// ,Ϊ"CrossRegionDetection"ʱЧ
		CFG_PASTE_INFO				stuPasteCfg;			// ATM,Ϊ"PasteDetection"ʱЧ
		CFG_LEFT_INFO				stuLetfCfg;				// Ʒ,Ϊ"LeftDetection"ʱЧ
		CFG_PRESERVATION_INFO		stuPreseRvationCfg;		// Ʒȫ,Ϊ"Preservation"ʱЧ
		CFG_STAY_INFO				stuStayCfg;				// ͣ,Ϊ"StayDetection"ʱЧ
		CFG_WANDER_INFO				stuWanderCfg;			// ǻ,Ϊ"WanderDetection"ʱЧ
		CFG_MOVE_INFO				stuMoveCfg;				// ˶,Ϊ"MoveDetection"ʱЧ
		CFG_TAIL_INFO				stuTailCfg;				// β,Ϊ"TailDetection"ʱЧ
		CFG_RIOTER_INFO				stuRioterCfg;			// ۼ,Ϊ"RioterDetection"ʱЧ
		CFG_FIGHT_INFO				stuFightCfg;			// ܹ,Ϊ"FightDetection"ʱЧ
		CFG_FIRE_INFO				stuFireCfg;				// ,Ϊ"FireDetection"ʱЧ
		CFG_SMOKE_INFO				stuSmokeCfg;			// ,Ϊ"SmokeDetection"ʱЧ
		CFG_FLOWSTAT_INFO			stuFlowStatCfg;			// ͳƹ, Ϊ"FlowStat"ʱЧ
		CFG_NUMBERSTAT_INFO			stuNumberStatCfg;		// ͳƹ,Ϊ"NumberStat"ʱЧ
		CFG_TRAFFICCONTROL_INFO		stuTraControlCfg;		// ͨƹ,Ϊ"TrafficControl"ʱЧ
		CFG_TRAACCIDENT_INFO		stuAccidentCfg;			// ͨ¹ʹ,Ϊ"TrafficAccident"ʱЧ
		CFG_TRAJUNCTION_INFO		stuJunctionCfg;			// ·ڹ,Ϊ"TrafficJunction"ʱЧ
		CFG_TRAFFICGATE_INFO		stuTrafficGateCfg;		// ڹ,Ϊ"TrafficGate"ʱЧ
		CFG_FACEDETECT_INFO			stuFaceDetectCfg;		// ,Ϊ"FaceDetect"ʱЧ
	} ruleEvent;
};

// Ϣ
struct IvsDecodeInfo
{
	LLONG				dev_id;			// 豸ID
	int					chnl_idx;		// ͨ
	int					decoder_id;		// ˿
	HWND				hwnd;			// Ƶʾ

	bool				bShowRule;		// Ƿʾܷ
	bool				bShowObj;		// Ƿʾ˶Ŀ
	bool				bShowLocus;		// Ƿʾ˶켣
};

// ܷϢ
struct IvsRule
{
	int					rule_id;				// 
	int					trigger_cnt;			// 
 	IvsRuleInfo			ruleInfo;				//Ϣ
	IvsRule()
	{
		memset(&ruleInfo, 0 , sizeof(ruleInfo));
		rule_id = 0;
		trigger_cnt = 0;
	}
};

typedef std::map<int,IvsRule*>		IvsRuleMap;		// ID ==> 
typedef DH_RECT				IvsRect;
typedef std::list<CFG_POLYLINE>		IvsLocusSeg;	// һ˶켣
typedef std::list<IvsLocusSeg>		IvsLocus;		// Ŀ˶켣

struct IvsObject
{
	int					object_id;			// ˶ĿID
	int					opt_type;			// Ϊࣺ(1), 켣(2)ɾ(3)켣(4),ֵЧ
	int					alarm_cnt;			// ˶Ŀ걨
	int					display_cnt;		// ˶Ŀʾ
	IvsRect				obj_rect;			// ˶Ŀ
 	IvsLocus			obj_locus;			// ˶켣
};

typedef std::map<int,IvsObject>		IvsObjectMap;	// ˶ĿID ==> ˶Ŀ

// ͨϢ
struct IvsChnlInfo
{
	LLONG				dev_id;				// 豸ID
	int					chnl_idx;			// ͨ
	BOOL				bEnableIvs;			// ͨǷܷ
	BOOL				bAtm;				// ATM豸?
	BYTE				bPreset;			// 

	/*
		ʹĸ˿ڵĹ켣Ϣ:
		һ豸ܱͨδ,жʵʱڽ,еĹ켣ϢӦöһ,
		ֻʹһʵʱеĹ켣ϢͿ.ֶָʾʹĸ˿ϱĹ켣Ϣ.
	*/
	int					live_dec_id;
	IvsRuleMap			rule_map;			// 
	IvsObjectMap		mapId2Obj;			// ˶Ŀб
};

struct ReloadIvsRuleReq
{
	LLONG				devHandle;
	int					nChnlIdx;
	bool				bReloadCfg;
	bool				bAddNew;
	int					nDecPort;
	HWND				hVideoWnd;
	int					nChnlCnt;
};

class CIvsModule : public CWnd
{
public:
	// 豸ͨʱȡܷ
	static int OnOpenDeviceRealplay(LLONG lDevHandle,int nChnlIdx,int nDecoderPort,HWND hwnd,int nChnlCnt);
	static void ReloadIvsRuleProc(ReloadIvsRuleReq* pReq);
	static int GetDeviceIvsConfig(DEV_INFO& devInfo);
	static int GetRulesMaxStructSize(DWORD *pRulesTypes, int nRuleNum);

	// ¶ȡܷͨ
	static int ReloadChannelIvsRule(LLONG lDevHandle,DEV_INFO &devInfo,int nChnlIdx,
		bool bAddNew = true,int  nDecPort = -1);

	// ƹ˶Ŀ(켣)
	static int DrawIvsRuleProc(IvsChnlInfo* pChnlInfo,HDC hdc);
	static void DrawIvsRule(IvsRule* pIvsRule,HDC hdc);
	static int DrawIvsObjectProc(IvsChnlInfo* pChnlInfo,IvsDecodeInfo* pDecInfo,HDC hdc);
	
	// Ƽͷ
	static void DrawDirectionArrow(HDC hdc,POINT ptStart,POINT ptEnd,int nDirection,HRGN hrgn = NULL);

	static void DrawIvsObjectLocus(IvsObject* pIvsObj, HDC hdc);
	static void DrawIvsObjectBoundBox(IvsObject* pIvsObj, HDC hdc);


	static void __stdcall GetIvsInfoProc(char* buf, long type, long len, long reallen, void* reserved, void* nUser);
	static void __stdcall DrawIvsInfoProc(long nPort,HDC hdc,LONG nUser);

	static BOOL Init();
	static BOOL UnInit();

	static void ClearData();
protected:
private:
	CIvsModule(){}
	virtual ~CIvsModule();
	static void* AllocateMemory(UINT nSize);
	static void FreeMemory(void* pMem);

private:
	static HANDLE								m_hIvsHeap;
	static std::map<int,IvsDecodeInfo>			m_decode_info_map;		// ˿ں ==> Ϣ
	static std::list<IvsChnlInfo>				m_chnl_info_list;		// ͨϢ
	static CRITICAL_SECTION						m_cs;
};