/********************************************************************
 * File: dhplayEx.h
 * Copyright:
 * Author:Zhou Guofeng/Wang Weifen 
 * Created: 2006.12
 * purpose:Function interface definition and explanatino for user 2nd development.
*********************************************************************/
#ifndef _DHPLAY_EX_H
#define _DHPLAY_EX_H

#include "dhplay.h"

#ifdef	__cplusplus
extern "C" {
#endif

#define PIC_BMP_32                      0       //BMP32
#define PIC_BMP_24                      1       //BMP24

/*ݾɰ汾۽ӿ*/
typedef enum
{
	FISHSHOWMODE_WALL_PANORAMA = 0,       //װȫģʽ
	FISHSHOWMODE_CEIL_PANORAMA,           //װ360ȫ
	FISHSHOWMODE_CEIL_PANORAMA_TWO,       //װ180ȫ
	FISHSHOWMODE_FLOOR_PANORAMA,          //ذ尲װ360ȫ
	FISHSHOWMODE_FLOOR_PANORAMA_TWO,      //ذ尲װ180ȫ 
	FISHSHOWMODE_ONE_O_THREE,             //1+3ģʽ
	FISHSHOWMODE_CEIL_ONE_REGION = 10,    //װeptz
	FISHSHOWMODE_CEIL_FOUR_REGION,        //װ4eptz
	FISHSHOWMODE_ORIGINAL,                //ԭʼģʽֱԭʼ
	FISHSHOWMODE_WALL_ONE_REGION,         //װeptz
	FISHSHOWMODE_WALL_FOUR_REGION,        //װ4eptz
	FISHSHOWMODE_FLOOR_ONE_REGION,        //ذ尲װeptz
	FISHSHOWMODE_FLOOR_FOUR_REGION,       //ذ尲װ4eptzԭʼ
	FISHSHOWMODE_WALL_ONE_O_THREE,	      //ذ1+3ģʽ
	FISHSHOWMODE_CEIL_ONE_O_THREE,	      //װ1+3ģʽ
	FISHSHOWMODE_FLOOR_ONE_O_THREE,	      //װ1+3ģʽ

}FISHSHOWMODES;

typedef enum
{
	FISHEPTZOPT_UPDATE_FOCUS,                   //½
	FISHEPTZOPT_ZOOM_IN,                        //Ŵ
	FISHEPTZOPT_ZOOM_OUT,                       //С
	FISHEPTZOPT_MOVE_UP,                        //ƶ
	FISHEPTZOPT_MOVE_DOWN,                      //ƶ
	FISHEPTZOPT_MOVE_LEFT,                      //ƶ
	FISHEPTZOPT_MOVE_RIGHT,                     //ƶ
	FISHEPTZOPT_AUTO_ROTATE_CLOCKWISE,          //Զ˳ʱת
	FISHEPTZOPT_AUTO_ROTATE_COUNTERCLOCKWISE,   //Զʱת
	FISHEPTZOPT_STOP_AUTO_ROTATE,				//ֹͣԶת
	FISHEPTZOPT_GET_POSITION,					//ȡǰ̨λ
	FISHEPTZOPT_SELECT_REGION_ZOOMIN_ON,        //ѡŴ
	FISHEPTZOPT_SELECT_REGION_ZOOMIN_OFF,		//˳ѡŴ
	FISHEPTZOPT_RESTORE_DEFAULT_LOCATION,		//ָ̨Ĭλ

}FISHEPTZOPTS;
/***************/

#ifdef MFPTZ_OPEN
//@begin
typedef struct
{
	int   himg_width;                       //ͼ
	int   himg_height;                      //ͼ
	int   *zoom_list;						/**/
	int    zoom_list_size;					/*λ*/
}MHFPTZ_INITPARAM;
//@end
#endif

#ifdef FTRACK_MODE
typedef struct
{
	int radius;      //ԭʼԲ뾶Ϊ8192ϵ
	int originX;     //ԭʼԲԲġΪ8192
	int originY;
	int src_width;   //ԭʼԲͼ
	int src_height;
	FISHEYE_MOUNTMODE mount_mode;     //װģʽ
	FISHEYE_CALIBRATMODE calib_mode;  //ģʽ
	SUBWIN_INFO sub_win_info;         //ӴϢòͨFisheye_GetParam()ӿڿɻȡ
}FISHRECTIFY_INFO;
#endif

// Ϣ
typedef struct __DATETIME_INFO
{
	unsigned int			nYear;			// 
	unsigned int			nMonth;			// 
	unsigned int			nDay;			// 
	unsigned int			nHour;			// ʱ
	unsigned int			nMinute;		// 
	unsigned int			nSecond;		// 
	unsigned int			nMilliSecond;	// 
}DATETIME_INFO;

typedef struct 
{
	char*	pHead;
	int		nLen;
	char*	pBody;
	int		nBodyLen;
	
	int		nRet;				//0: decode 1://don't decode
	char	reserved[128];
}DemuInfoEx;

typedef struct
{
	int type;			// 1:VIDEO, 2:AUDIO, 3:DATA
	int subtype;		// I Frame, BP Frame, PCM8, MS-ADPCM etc.
	int encode;			// MPEG4, H264, STDH264
	int sequence;		// I֡
	
	// ͼСϢ
	int width;
	int height;
	
	// ֡Ϣ
	int rate;
	
	// ʱϢ
	int year;
	int month;
	int day;
	int hour;
	int minute;
	int secode;
	LONG timestamp;
	
	int channels;
	int bitspersample;
	int samplespersecond;
}DEMUX_INFO;

// ļϢ֡
typedef struct __FILE_INFO_FRAME
{
	unsigned int		nFrameSubType;	  // ֡ͣ֡¼֡
	DATETIME_INFO*		pstDateTimeStart; // ʼʱ
	DATETIME_INFO*		pstDateTimeEnd;   // ʱ
	unsigned char*		pFrameData;		  // ֡
	unsigned int		nFrameDataLen;	  // ֡ݳ
} FILE_INFO_FRAME;

typedef struct __FILE_INFO_FRAME_SEARCH
{
	unsigned int		nFileFrameType;		//ͣϣ PLAYER_INFO_TYPE_MOTIONDECT | PLAYER_INFO_TYPE_EVENT
	DATETIME_INFO		stStartDataTime;    //ʼʱ
	DATETIME_INFO		stEndDataTime;      //ʱ
	DISPLAYRECT			rtDetectedRegion;   //еĶⷶΧ֡ʱЧΪ0ʱʾȫ
	DISPLAYRECT			rtTotal;			//, ֡ʱЧ
} FILE_INFO_FRAME_SEARCH;

typedef struct __FILE_INFO_IMAGE
{
	tPicFormats	   imageType;				// ͼƬ
	unsigned char* pPicBuf;					// ͼƬĻָ
	unsigned int   nPicBufLen;				// ͼƬĳ

} FILE_INFO_IMAGE;

typedef struct NativeHandle
{
	void* display;
	void* context;
	void* surface;

}Android_NativeHandle;

// ļϢ֡ͣӦFILE_INFO_FRAME_SEARCHṹеnFileFrameType
#define PLAY_INFO_TYPE_MOTIONDECT     1         // 
#define PLAY_INFO_TYPE_EVENT		  2         // ¼

//ģʽܿ
#define NEWFUNC_PHONE_MODEL 0x01     //ֻģʽ
#define NEWFUNC_FTRACK_MODE_CR 0x02  //1+1ģʽ1ģʽ
#define NEWFUNC_FTRACK_MODE_RT 0x06  //ʹ1ͼٽת깦

/************************************************************************/
/* ǿֵ֧Ĺ                                                         */
/************************************************************************/
typedef enum 
{
	IVSEFUNCTYPE_DEHAZE,	    // ȥ
	IVSEFUNCTYPE_DENOISE,		// ȥ
	IVSEFUNCTYPE_WB,			// ƫɫУ
	IVSEFUNCTYPE_LOWLIGHT,		// նǿ
	IVSEFUNCTYPE_HDR,			// ̬
	IVSEFUNCTYPE_NUM			// ֧ǿĹܸ
}IVSEFUNCTYPE;

/************************************************************************/
/* ROIͶ                                                        */
/************************************************************************/
typedef struct
{
    int x;          // Ͻx
    int y;          // Ͻy
    int width;      // 
    int height;     // ߶
}IVSEROI;

/************************************************************************/
/* Ƶǿ㷨                                                           */
/************************************************************************/
typedef struct
{
    IVSEFUNCTYPE eFuncType;   // ѡ
    IVSEROI		 cRoi;        // ROI 
	int			 nMode;       // 0ʾͼƬģʽ 1ʾƵģʽ
    int			 nProcess_param[2];     // Χ[1,5]
	/*
    ܺ	                process_param[0]	    process_param[1]
    IVSEFUNCTYPE_DEHAZE	        	                Ͷ
    IVSEFUNCTYPE_DENOISE	    	                - ƵģʽЧ
    IVSEFUNCTYPE_WB	        -	                    -
    IVSEFUNCTYPE_LOWLIGHT	-   	                Ͷ
    IVSEFUNCTYPE_HDR	        0: 1:ҹ 2:Զ  	
    */

}IVSEPARAMS;

/********************************************************************
*	: 	    	PLAY_SetupPrepareTime
*	Ŀ:				Ԥ¼Ļ
*   :           nPort:		ͨ
						nTime:		Ԥ¼
						tmpDir:		ʱԤ¼Ŀ¼
*   :        
*   ֵ:             TRUE:	ɹ.
						FALSE:	ʧ
*   ʱ:	        2012:12:21  
*   汾Ϣ¼:	    2012/12/21:YeYamin:modify......
*********************************************************************/

PLAYSDK_API BOOL	CALLMETHOD PLAY_SetupPrepareTime(LONG nPort,int nTime,const char* tmpDirectory);

/********************************************************************
*	: 	    	PLAY_StartPrepareRecord
*	Ŀ:				ʼԤ¼
*   :		     nPort:		ͨ
						 pFileName:	¼λ
*   :        
*   ֵ:             TRUE:	ɹ.
						FALSE:	ʧ
*   ʱ:	        2012:12:21  
*   汾Ϣ:			2012/12/21:YeYamin:modify......
*********************************************************************/

PLAYSDK_API BOOL	CALLMETHOD PLAY_StartPrepareRecord(LONG nPort,const char* pFileName);

/********************************************************************
*	: 	    	PLAY_StopPrepareRecord
*	Ŀ:	
*   :			port:		ͨ
*   :        
*   ֵ:             TRUE:	ɹ.
						FALSE:	ʧ
*   ʱ:	        2012:12:21  
*   汾Ϣ¼:		2012/12/21:YeYamin:modify......
*********************************************************************/

PLAYSDK_API BOOL	CALLMETHOD PLAY_StopPrepareRecord(LONG nPort);

//
// 
#define IVSINFOTYPE_PRESETPOS		1
#define IVSINFOTYPE_MOTINTRKS		2
#define IVSINFOTYPE_MOTINTRKS_EX	3
#define IVSINFOTYPE_LIGHT			4
#define IVSINFOTYPE_RAWDATA			5
#define IVSINFOTYPE_TRACK			6
#define IVSINFOTYPE_MOTIONFRAME		9 /*̬֡*/
#define PSIVS						240
/********************************************************************
*	: 	    	PLAY_SetIVSCallBack
*	Ŀ:	
*   :	        nPort:		ͨ
						pFunc:		ýص
						nUser:		ģڻصĲ
*   :        
*   ֵ:             TRUE:	ɹ 
						FALSE:	ʧ
*   ʱ:	        2012:12:21  
*	汾Ϣ¼:	    2012/12/21:YeYamin:modify......
*********************************************************************/

typedef void (CALLMETHOD *GetIVSInfoCallbackFunc)(char* buf, LONG type, LONG len, LONG reallen, void* pReserved, void* pUserData);
PLAYSDK_API BOOL CALLMETHOD PLAY_SetIVSCallBack(LONG nPort, GetIVSInfoCallbackFunc pFunc, void* pUserData);

/********************************************************************
*	: 	    	PLAY_CatchResizePic
*	Ŀ:				ıֱʵץͼ     
*   :			nPort:		ͨ
						sFileName:	ͼƬַ.
						lTargetWidth & lTargetHeight: ͼƬĿ
						ePicfomat:	picture format (jpeg/bmp)	ͼƬ
*   :
*   ֵ:             TRUE:	ɹ 
						FALSE:	ʧ
*   ʱ:	        2012:12:21  
*   汾Ϣ¼:	    2012/12/21:YeYamin:modify......
*********************************************************************/

PLAYSDK_API BOOL CALLMETHOD PLAY_CatchResizePic(LONG nPort, char* sFileName, LONG lTargetWidth, LONG lTargetHeight, tPicFormats ePicfomat);

/********************************************************************
*	: 	    	PLAY_GetRealFrameBitRate
*	Ŀ:				ȡ
*   :           nPort:		ͨ
*   :	        pBitRate:
*   ֵ:             TRUE:	ɹ 
						FALSE:	ʧ
*   ʱ:	        2012:12:21  
*   汾Ϣ¼:	    2012/12/21:YeYamin:modify......
*********************************************************************/

PLAYSDK_API BOOL CALLMETHOD PLAY_GetRealFrameBitRate(LONG nPort, double* pBitRate);

/********************************************************************
*	: 	    	PLAY_StartAVIResizeConvert
*	Ŀ:				ıֱʵAVIת
*   :           nPort:		ͨ
						sFileName:	AVI¼ŵַ
						lWidth & lHeight:AVI¼Ŀ
*   :	        
*   ֵ:             TRUE:	ɹ 
						FALSE:	ʧ
*   ʱ:	        2012:12:21  
*   汾Ϣ¼:	    2012/12/21:YeYamin:modify......
*********************************************************************/

PLAYSDK_API BOOL CALLMETHOD PLAY_StartAVIResizeConvert(LONG nPort, char *sFileName, LONG lWidth, LONG lHeight);

/********************************************************************
*	: 	    	PLAY_StopAVIResizeConvert
*	Ŀ:				AVIת
*   :           nPort:		ͨ
*   :	        
*   ֵ:             TRUE:	ɹ 
						FALSE:	ʧ
*   ʱ:	        2012:12:21  
*   汾Ϣ¼:	    2012/12/21:YeYamin:modify......
*********************************************************************/

PLAYSDK_API BOOL CALLMETHOD PLAY_StopAVIResizeConvert(LONG nPort);

/********************************************************************
*	: 	    	PLAY_SetPandoraWaterMarkCallBack
*	Ŀ:				Ч
*   :         
*   :	        
*   ֵ:             TRUE:	ɹ 
						FALSE:	ʧ
*   ʱ:	        2012:12:21  
*   汾Ϣ¼:	    2012/12/21:YeYamin:modify......
*********************************************************************/

PLAYSDK_API BOOL CALLMETHOD PLAY_SetPandoraWaterMarkCallBack(LONG nPort, GetWaterMarkInfoCallbackFunc pFunc, void* pUserData);


/********************************************************************
*	: 	    	PLAY_SetDigitalSignCallBack
*	Ŀ:				ǩص.
*   :           nPort:		ͨ
						nFrameID:	֡
						bSuccess:	УǷͨ
						pUserData   û
*   :	        
*   ֵ:             TRUE:	ɹ 
						FALSE:	ʧ
*********************************************************************/
typedef void (CALLBACK* fCheckDigitalSignCB)(LONG nPort, int nFrameID, BOOL bSuccess, void* pUserData);
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDigitalSignCallBack(LONG nPort, fCheckDigitalSignCB pDigitalSignCB, void* pUserData);

/********************************************************************
*	: 	    	PLAY_GetTimePicture
*	Ŀ:				þʱͼƬ
*   :           filepath:	ļ·
						time:		ʱ
						DecCBFun:	ýȥĽص
						user:		û
*   :	        
*   ֵ:             TRUE:	ɹ 
						FALSE:	ʧ
*   ʱ:	        2012:12:21  
*   汾Ϣ¼:	    2012/12/21:YeYamin:modify......
*********************************************************************/
PLAYSDK_API BOOL CALLMETHOD PLAY_GetTimePicture(const char* filepath, struct tm* time, fDecCBFun fcbDec, void* pUserData);

//------------------------------------------------------------------------
// : PLAY_StartFisheyeEx
// : չӿڣҪfisheye.dll MCL_FPTZ.dll
// : [in] nPort : ͨ
//		 [in] startType:  ͣ 0ֻУ, 1ͬʱУ, 2ֻ㷨
//		 [in] funcType:   ЩܣĬΪ0, ýӿģʽпѡ, NEWFUNC_PHONE_MODEL|NEWFUNC_FTRACK_MODE_CR|NEWFUNC_FTRACK_MODE_RT
//       [in] ptzChannelParam: ʼͨstartTypeΪ0ʱptzChannelParamNULL
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_StartFisheyeEx(LONG nPort, int startType, int funcType, MHFPTZ_INITPARAM* ptzChannelParam);

//------------------------------------------------------------------------
// : PLAY_SetFisheyeParams, ݾɰ汾۽ӿ
// : ۲
// : [in]nPort           :  ͨ
//		 [in]nX				 :  Բĺ
//       [in]nY				 :  Բ
//       [in]nRadius         :  ۰뾶
//       [in]nLensDirection  :  ͷ 
//       [in]mode            :  ͼʾģʽ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetFisheyeParams(LONG nPort, int nX, int nY, int nRadius, int nLensDirection, FISHSHOWMODES mode);

//------------------------------------------------------------------------
// : PLAY_FisheyeGetPosition, ݾɰ汾۽ӿ
// : ĿĶӦ̨Ľλ
// : [in]nPort           :  ͨ
//		 [in]row			 :  Ŀ
//       [in]column			 :  Ŀ
//		 [out]pX     		 :  ĿӦ̨Ľ
//       [out]pY		     :  ĿӦ̨Ľ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_FisheyeGetPosition(LONG nPort, int row, int column, int *pX, int *pY);

//------------------------------------------------------------------------
// : PLAY_FisheyeEptzUpdate, ݾɰ汾۽ӿ
// : eptz(̨ƶ
// : [in]nPort           :  ͨ
//		 [in/out]pX			 :  eptz̨Ľ
//       [in/out]pY			 :  eptzĽ
//		 [in/out]pHangle		 :  eptzˮƽǶȷΧ(0-3600)
//       [in/out]pVangle		 :  eptzĴֱǶȷΧ(0-900)
//       [in]ops             :  FISHEPTZOPTSṹ,Ϊ0ʱָý㣬Ϊ1ʾŴ2ʾС3ʾƶ
//                              4ʾƶ5ʾƶ6ʾƶ7ʾԶ˳ʱת8ʾԶʱת
//								9ʾֹ̨ͣ10ʾȡǰ̨λ
//       [in]nWinNum         :  ҪeptzĴڱţϽwin_numΪ1ҵ
//       [in]nZoomStep       :  ŴСĲ, Χ1-8
//       [in]nPtStep		 :  ƶĲ, Χ1-8
//		 [in]nRotateStep	 :  תĲ, Χ1-8
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_OldFisheyeEptzUpdate(LONG nPort, int *pX, int *pY, int *pHAngle, int *pVAngle, FISHEPTZOPTS ops, int nWinNum,
												   int nZoomStep, int nPtStep, int nRotateStep);

/******************************************************************************
*
*   : Fisheye_TrancForm_TrackFrame
*     : 1ģʽ£ivs֡еĵǰ֡Ŀ켣תԭʼԲ
*     : - handle: 㷨ʵ
			- ptrackframe: ֡
			- track_frame_size֡С
*     : - ptrackframeԭʼԲװԭ֡
* ֵ  : DH_FISHEYE_ERROR_NONE: ɹ
*           other: ʧܡ
*******************************************************************************/ 	
PLAYSDK_API BOOL CALLMETHOD PLAY_FisheyeTrancFormTrackFrame(LONG nPort, void *ptrackframe,int track_frame_size);

/******************************************************************************
*
*   : Fisheye_TrancForm_coordinate
*     : ͼ꣬ԭʼԲԲ
*     : - param FishRectify_Info
			- inrpt㣬8192ϵ
			  
*     : - orpt㣬8192ϵ
			v:ת
* ֵ  : DH_FISHEYE_ERROR_NONE: ɹ
*           other: ʧܡ
*******************************************************************************/ 	
PLAYSDK_API BOOL CALLMETHOD PLAY_FisheyeTrancFormCoordinate(FISHRECTIFY_INFO *param, FISHEYE_POINT2D* inrpt,
	FISHEYE_POINT2D *orpt);
		
/******************************************************************************
*
*   : Fisheye_TrancForm_Curve
*     : ͼ꣬ԭʼԲԲ
*     : - param FishRectify_Info
            - rpt1:ͼϵһ㣬8192ϵ
			- rpt2ͼϵһ㣬8192ϵ
			- in_numĵ
*     : - in_numֵĵ˵
            - fptsֵõĵУ˵㣬8192ϵ
* ֵ  : DH_FISHEYE_ERROR_NONE: ɹ
*           other: ʧܡ
*******************************************************************************/ 	
PLAYSDK_API BOOL CALLMETHOD PLAY_FisheyeTrancFormCurve(FISHRECTIFY_INFO *param,
	FISHEYE_POINT2D* rpt1,FISHEYE_POINT2D* rpt2,int *in_num,
	FISHEYE_POINT2D *fpts);

//------------------------------------------------------------------------
// : PLAY_StartDeNoise
// : Ƶȥ㷨,Ҫ3dnr.dll
// : [in]nPort : ͨ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_StartDeNoise(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_SetDeNoiseParams
// : Ƶȥ
// : [in]nPort           :  ͨ
//		 [in]nTemporal		 :  ʱȥǿ [0,32]
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDeNoiseParams(LONG nPort, int nTemporal);

//------------------------------------------------------------------------
// : PLAY_StopDeNoise
// : ֹͣƵȥ㷨
// : [in]nPort : ͨ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_StopDeNoise(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_StartDeHaze
// : Ƶȥ㷨ܣҪdehazing.dll
// : [in]nPort : ͨ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_StartDeHaze(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_SetDehazeParams
// : Ƶȥ
// : [in]nPort           :  ͨ
//		 [in]ALightValue	 :	趨ĴǿֵΧ0-255
//		 [in]AutoLightOn	 :  ĬΪ1,ԶѰҴǿ0-رԶֶ
//       [in]AutoRun		 :	ĬΪ1,һֱȥܣ0-ԶжǷ첢ȥ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDehazeParams(LONG nPort, int ALightValue, int AutoLightOn, int AutoRun);

//------------------------------------------------------------------------
// : PLAY_STOPDeHaze
// : ֹͣƵȥ㷨
// : [in]nPort : ͨ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_StopDeHaze(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_StartIVSE
// : Ƶǿ㷨ܣҪIvseDll.dll
// : [in]nPort : ͨ
// : BOOL,ɹTRUE,ʧܷFALSE.
//
// ע⣺㷨ʱϳ鴦Ƶ
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_StartIVSE(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_SetIVSEParams
// : ƵǿԶεʹöIVSEĹ
// : [in]nPort           :  ͨ
//		 [in]pIVSEParams	 :	IVSEPARAMSṹ
//		 [in]bEnable		 :  ӦIVSEPARAMSеIVSEFUNCTYPEѡʹܿ	
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetIVSEParams(LONG nPort, IVSEPARAMS* pIVSEParams, BOOL bEnable);

//------------------------------------------------------------------------
// : PLAY_StopIVSE
// : ֹͣƵǿ㷨
// : [in]nPort : ͨ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_StopIVSE(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_ConvertToBmpFile
// : ͼʽתΪBMPʽ.
// : pBuf,ͼָ
//		 nSize,ͼݴС
//		 nWidth,ͼ
//		 nHeight,ͼ߶
//		 nType,.T_RGB32,T_UYVY.
//		 sFileName,Ҫļ.BMPΪļչ.
//       nBmpType, BMPͣPIC_BMP_32ʾBMP32 PIC_BMP_24ʾBMP24
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_ConvertToBmpFileEx(char * pBuf,LONG nSize,LONG nWidth,LONG nHeight,LONG nType, char *sFileName,int nBmpType);

//------------------------------------------------------------------------
// : PLAY_EnableLargePicAdjustment
// : ǷøͼڲԣĬáòʱڿ4ʱֻI֡ʱÿ֡
// : [in]nPort           :  ͨ
//		 [in]bEnable		 :  TRUEʾô˹ܣFALSEʾرմ˹
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_EnableLargePicAdjustment(LONG nPort, BOOL bEnable);

//------------------------------------------------------------------------
// ͬŽӿ
//------------------------------------------------------------------------

//------------------------------------------------------------------------
// : PLAY_OpenPlayGroup
// : ͬ
// : 
// : ͬſƾڵͬſƽӿʱҪþNULLʾʧ
//------------------------------------------------------------------------
PLAYSDK_API void* CALLMETHOD PLAY_OpenPlayGroup();

//------------------------------------------------------------------------
// : PLAY_AddToPlayGroup
// : һ·ѾƵͬ
// : hPlayGroup,ͬžPLAY_OpenPlayGroup
//       nPort,ͨ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_AddToPlayGroup(void* hPlayGroup, LONG nPort);

//------------------------------------------------------------------------
// : PLAY_DelFromPlayGroup
// : ͬŶɾָͨ
// : hPlayGroup,ͬžPLAY_OpenPlayGroup
//       nPort,ͨ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_DelFromPlayGroup(void* hPlayGroup, LONG nPort);

//------------------------------------------------------------------------
// : PLAY_SetPlayGroupDirection
// : ӵǰʱŻ򵹷
// : hPlayGroup,ͬžPLAY_OpenPlayGroup
//		 nDirection,ŷ0ǰ1
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetPlayGroupDirection(void* hPlayGroup, int nDirection);

//------------------------------------------------------------------------
// : PLAY_SetPlayGroupSpeed
// : òٶ
// : hPlayGroup,ͬžPLAY_OpenPlayGroup
//		 fCoff,ٶ,Χ[1/64~64.0],С1ʾţ1ʾ.
//			   ٶȽϿʱܻ֡.
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetPlayGroupSpeed(void* hPlayGroup, float fSpeed);

//------------------------------------------------------------------------
// : PLAY_PausePlayGroup
// : ͣ
// : hPlayGroup,ͬžPLAY_OpenPlayGroup
//		 bPause,TRUEͣ,FLASEָ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_PausePlayGroup(void* hPlayGroup, BOOL bPause);

//------------------------------------------------------------------------
// : PLAY_StepPlayGroup
// : ֡
// : hPlayGroup,ͬžPLAY_OpenPlayGroup
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_StepPlayGroup(void* hPlayGroup);

//------------------------------------------------------------------------
// : PLAY_StepPlayGroup
// : þʱжλ
// : hPlayGroup,ͬžPLAY_OpenPlayGroup
//	     pstDateTime,ʱ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SeekPlayGroup(void* hPlayGroup, DATETIME_INFO* pstDateTime);

//------------------------------------------------------------------------
// : PLAY_ClosePlayGroup
// : رͬſ
// : hPlayGroup,ͬžPLAY_OpenPlayGroup
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_ClosePlayGroup(void* hPlayGroup);


//------------------------------------------------------------------------
// : PLAY_SetFileRefCallBack
// : ýص,ļʱļ.̺ʱȽϳ,Լ
//			ÿ봦40Mҵ,ΪӲ̶ݱȽ,Ĺ
//			̨,ҪʹĺҪȴ̽,ӿڲӰ.
// : nPort,ͨ
//		 pFileRefDone,صָ,:
//			nPort,ͨ
//			pUserData,ûԶ
//		 pUserData,ûԶ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
typedef void(CALLBACK *fpFileRefDoneCBFun)(DWORD nPort, void* pUserData);									
PLAYSDK_API BOOL CALLMETHOD PLAY_SetFileRefCallBack(LONG nPort,
													fpFileRefDoneCBFun pFileRefDoneCBFunc,
													void* pUserData);

//------------------------------------------------------------------------
// : PLAY_SetDemuxCallBack
// : Դݷݻص
// : nPort,ͨ
//		 DecCBFun,ݻصָ
//			nPort,ͨ
//			pBuf,ָ
//			nSize,ݳ
//			pParam,֡Ϣ  ָDEMUX_INFOṹ 
//			nReserved,
//			pUserData,ûԶ
//		 pUserData,ûԶ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
typedef void (CALLBACK* fDemuxDecCBFun)(LONG nPort,char * pBuf,	LONG nSize,void * pParam,void* pReserved, void* pUserData);
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDemuxCallBack(LONG nPort, fDemuxDecCBFun DecCBFun, void* pUserData);

//------------------------------------------------------------------------
// : PLAY_SetFileDoneTimeCallBack
// : ļʼʱصļʼͽʱøûص
// : nPort,ͨ
//		 fFileTimeDoneCBFun,صָ,ΪNULL,:
//			nPort,ͨ
//			nStartTime, ļʼʱ.197011000.
//			nEndTime, ļʱ.197011000.
//			pUserData, ûԶ
//		 pUserData, ûԶ.
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
typedef void (CALLBACK* fFileTimeDoneCBFun)(LONG nPort, DWORD nStarTime, DWORD nEndTime, void* pUserData);
PLAYSDK_API BOOL CALLMETHOD PLAY_SetFileTimeDoneCallBack(LONG nPort, fFileTimeDoneCBFun FileTimeCBFun, void* pUserData);

//------------------------------------------------------------------------
// : PLAY_GetKeyFramePosByAbsoluteTime
// : ʱָλ֮ǰĹؼ֡λ.
// : nPort,ͨ
//		 t,ʱ,SYSTEMTIME.õʱ.עִгɹֵ洢I֡ʱ
//		 framePos,ҵĹؼ֡ļλϢṹָ,PFRAME_POS.
// : BOOL,ɹTRUE,ʧܷFALSE.
PLAYSDK_API BOOL CALLMETHOD PLAY_GetKeyFramePosByAbsTime(LONG nPort, SYSTEMTIME* t, FRAME_POS* framePos);

//------------------------------------------------------------------------
// : PLAY_GetNextKeyFramePosByAbsoluteTime
// : ʱָλ֮Ĺؼ֡λ.
// : nPort,ͨ
//		 t,ʱ,SYSTEMTIME.õʱ.עִгɹֵ洢صI֡ʱ
//		 framePos,ҵĹؼ֡ļλϢṹָ,PFRAME_POS.
// : BOOL,ɹTRUE,ʧܷFALSE.
PLAYSDK_API BOOL CALLMETHOD PLAY_GetNextKeyFramePosByAbsTime(LONG nPort, SYSTEMTIME* t, FRAME_POS* framePos);

//------------------------------------------------------------------------
// : PLAY_QueryGroupPlayingTime
// : ѯǰڲŵʱ.
// : nPort,ͨ
//		 pDateTime,ʱ
// : BOOL,ɹTRUE,ʧܷFALSE.
PLAYSDK_API BOOL CALLMETHOD PLAY_QueryGroupPlayingTime(void* hPlayGroup,  DATETIME_INFO *pDateTime);

//------------------------------------------------------------------------
// : PLAY_GetAudioChannels
// : ȡƵͨ
// : nPort,ͨ
//       pChannels, [0-255].
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_GetAudioChannels(LONG nPort, DWORD* pChannels);

//------------------------------------------------------------------------
// : PLAY_ChooseAudio
// : ѡƵͨ
// : nPort,ͨ
//       nChannelID, Ƶͨ0ʼ.
//       bFlag,TRUE,FALSEر
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_ChooseAudio(LONG nPort, DWORD nChannelID, BOOL bFlag);

//------------------------------------------------------------------------
// : PLAY_GetAudioChooseState
// : ȡƵͨ򿪹ر״̬
// : nPort,ͨ
//       nChannelID, Ƶͨ[0-255].
//       pFlag,TRUE,FALSEر
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_GetAudioChooseState(LONG nPort, DWORD nChannelID, BOOL* bFlag);

//------------------------------------------------------------------------
// : PLAY_SetPlayedAbsTime
// : ʱòʱ
// : nPort,ͨ
//		 pDateTime,ʱ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetPlayedAbsTime(LONG nPort, DATETIME_INFO *pDateTime);

//------------------------------------------------------------------------
// : PLAY_SetPlayPosByFileOffset
// : ļƫòλ
// : nPort,ͨ
//		 nFileOffset,ļƫλ
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetPlayPosByFileOffset(LONG nPort, UINT nFileOffset);

//------------------------------------------------------------------------
// : PLAY_GetCurrentFrameRateEx
// : õǰ֡ʣСʽ
// : nPort,ͨ
// : float,ǰ֡
//------------------------------------------------------------------------
PLAYSDK_API float CALLMETHOD PLAY_GetCurrentFrameRateEx(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_InitDDraw
// : ˽ӿЧ
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_InitDDraw(HWND hWnd);

//------------------------------------------------------------------------
// : PLAY_GetCaps
// : ˽ӿЧ
//------------------------------------------------------------------------
PLAYSDK_API int	CALLMETHOD PLAY_GetCaps();

//------------------------------------------------------------------------
// : PLAY_GetFileHeadLength
// : ˽ӿЧ
//------------------------------------------------------------------------
PLAYSDK_API DWORD CALLMETHOD PLAY_GetFileHeadLength();

//------------------------------------------------------------------------
// : PLAY_RealeseDDraw
// : ˽ӿЧ
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_RealeseDDraw();

//------------------------------------------------------------------------
// : PLAY_GetDDrawDeviceTotalNums
// : ˽ӿЧ
//------------------------------------------------------------------------
PLAYSDK_API DWORD CALLMETHOD PLAY_GetDDrawDeviceTotalNums();

//------------------------------------------------------------------------
// : PLAY_SetDDrawDevice
// : ˽ӿЧ
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDDrawDevice(LONG nPort,DWORD nDeviceNum);

//------------------------------------------------------------------------
// : PLAY_GetDDrawDeviceInfo
// : ˽ӿЧ
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_GetDDrawDeviceInfo(DWORD nDeviceNum,LPSTR  lpDriverDescription,DWORD nDespLen,LPSTR lpDriverName ,DWORD nNameLen,LONG *hhMonitor);

//------------------------------------------------------------------------
// : PLAY_GetCapsEx
// : ˽ӿЧ
//------------------------------------------------------------------------
PLAYSDK_API int	CALLMETHOD PLAY_GetCapsEx(DWORD nDDrawDeviceNum);

//------------------------------------------------------------------------
// : PLAY_ThrowBFrameNum
// : ˽ӿЧ
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_ThrowBFrameNum(LONG nPort,DWORD nNum);

//------------------------------------------------------------------------
// : PLAY_InitDDrawDevice
// : ˽ӿЧ
//------------------------------------------------------------------------
PLAYSDK_API BOOL	CALLMETHOD PLAY_InitDDrawDevice();

//------------------------------------------------------------------------
// : PLAY_ReleaseDDrawDevice
// : ˽ӿЧ
//------------------------------------------------------------------------
PLAYSDK_API void CALLMETHOD PLAY_ReleaseDDrawDevice();

//------------------------------------------------------------------------
// : PLAY_Back
// : ˽ӿЧ
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_Back(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_SetDDrawDeviceEx
// : ˽ӿЧ 
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDDrawDeviceEx(LONG nPort,DWORD nRegionNum,DWORD nDeviceNum);


//------------------------------------------------------------------------
// : PLAY_SetOverlayMode
// : ˽ӿЧoverlayģʽѾʱ
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetOverlayMode(LONG nPort,BOOL bOverlay,COLORREF colorKey);


//------------------------------------------------------------------------
// : PLAY_GetOverlayMode
// : ˽ӿЧoverlayģʽѾʱ
//------------------------------------------------------------------------
PLAYSDK_API LONG CALLMETHOD PLAY_GetOverlayMode(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_GetColorKey
// : ˽ӿЧoverlayģʽѾʱ
//------------------------------------------------------------------------
PLAYSDK_API COLORREF CALLMETHOD PLAY_GetColorKey(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_ChangeRate
// : ӿPLAY_SetPlaySpeed
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_ChangeRate(LONG nPort, int rate);

//------------------------------------------------------------------------
// : PLAY_SetTimerType
// : ˽ӿЧ
PLAYSDK_API BOOL CALLMETHOD PLAY_SetTimerType(LONG nPort,DWORD nTimerType,DWORD nReserved);

//------------------------------------------------------------------------
// : PLAY_GetTimerType
// : ˽ӿЧ
PLAYSDK_API BOOL CALLMETHOD PLAY_GetTimerType(LONG nPort,DWORD *pTimerType,DWORD *pReserved);

//------------------------------------------------------------------------
// : PLAY_SetMDRange
// : ˽ӿЧ
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetMDRange(LONG nPort,DISPLAYRECT* rc,DWORD nVauleBegin,DWORD nValueEnd,DWORD nType);

//------------------------------------------------------------------------
// : PLAY_SetMDThreShold
// : ˽ӿЧ
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetMDThreShold(LONG nPort, DWORD ThreShold);

//------------------------------------------------------------------------
// : PLAY_GetMDPosition
// : ˽ӿЧ
//------------------------------------------------------------------------
PLAYSDK_API DWORD CALLMETHOD PLAY_GetMDPosition(LONG nPort, DWORD Direction, DWORD nFrame, DWORD* MDValue);


//------------------------------------------------------------------------
// : PLAY_CutFileSegment
// : ˽ӿЧ
//------------------------------------------------------------------------
typedef void (CALLBACK *CutProgressFunc)(DWORD nPort, int iProgress, DWORD dwUser);
PLAYSDK_API BOOL CALLMETHOD PLAY_CutFileSegment(LONG nPort, 
												LONG lBeginTime, 
												LONG lEndTime, 
												CutProgressFunc pFunc, 
												char *sOutFilePath, 
												DWORD dwUser);

//------------------------------------------------------------------------
// : PLAY_SetVideoPerTimer
// : ˽ӿЧ
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetVideoPerTimer(int iVal);


//------------------------------------------------------------------------
// : PLAY_GetVideoPerTimer
// : ˽ӿЧ
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_GetVideoPerTimer(int* pVal);

//------------------------------------------------------------------------
// : PLAY_InputVideoData
// : ˽ӿЧ
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_InputVideoData(LONG nPort,PBYTE pBuf,DWORD nSize);

//------------------------------------------------------------------------
// : PLAY_InputAudioData
// : ˽ӿЧ
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_InputAudioData(LONG nPort,PBYTE pBuf,DWORD nSize);

//------------------------------------------------------------------------
// : PLAY_SetVerifyCallBack
// : ˽ӿЧ
//------------------------------------------------------------------------
typedef void (CALLBACK * fVerifyCBFun)(LONG nPort, FRAME_POS * pFilePos, DWORD bIsVideo, void* pUserData);
PLAYSDK_API BOOL CALLMETHOD PLAY_SetVerifyCallBack(LONG nPort, DWORD nBeginTime, DWORD nEndTime, fVerifyCBFun VerifyFun, void* pUserData);


//------------------------------------------------------------------------
// : PLAY_SetSourceBufCallBack
// : ˽ӿЧ
//------------------------------------------------------------------------
typedef void (CALLBACK * fSourceBufCBFun)(LONG nPort,DWORD nBufSize, void* pUserData,void*pResvered);
PLAYSDK_API BOOL CALLMETHOD PLAY_SetSourceBufCallBack(LONG nPort,
													  DWORD nThreShold,
													  fSourceBufCBFun SourceBufCBFun,
													  void* pUserData,
													  void *pReserved);

//------------------------------------------------------------------------
// : PLAY_ResetSourceBufFlag
// : ˽ӿЧ
//------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_ResetSourceBufFlag(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_SetPandoraWaterMarkCallBack
// : ˽ӿЧ
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetPandoraWaterMarkCallBack(LONG nPort, GetWaterMarkInfoCallbackFunc pFunc, void* pUserData);

//------------------------------------------------------------------------
// : PLAY_SetDisplayBuf
// : ˽ӿЧ
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDisplayBuf(LONG nPort,DWORD nNum);

//------------------------------------------------------------------------
// : PLAY_GetDisplayBuf
// : ˽ӿЧ
//------------------------------------------------------------------------
PLAYSDK_API DWORD CALLMETHOD PLAY_GetDisplayBuf(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_SetDisplayType
// : ˽ӿЧ
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDisplayType(LONG nPort,LONG nType);

//------------------------------------------------------------------------
// : PLAY_GetDisplayType
// : ˽ӿЧ
//------------------------------------------------------------------------
PLAYSDK_API LONG CALLMETHOD PLAY_GetDisplayType(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_RefreshPlayEx
// : ˽ӿЧ
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_RefreshPlayEx(LONG nPort,DWORD nRegionNum);

//------------------------------------------------------------------------
// : PLAY_OpenStreamEx
// : ˽ӿЧ
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_OpenStreamEx(LONG nPort,PBYTE pFileHeadBuf,DWORD nSize,DWORD nBufPoolSize);

//------------------------------------------------------------------------
// : PLAY_CloseStreamEx
// : ˽ӿЧ
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_CloseStreamEx(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_AdjustFluency
// : ˽ӿЧ
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_AdjustFluency(LONG nPort, int level);

//------------------------------------------------------------------------
// : PLAY_SurfaceChange
// : Android汾רãSurface仯֪ͨ
// : 
// : 
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SurfaceChange(LONG nPort, HWND hWnd);

//------------------------------------------------------------------------
// : PLAYER_SetFileInfoFrameCallback
// : ļϢ֡ص
// : 
// : 
//------------------------------------------------------------------------
typedef int (CALLBACK* fOnFileInfoFrame)(LONG nPort, FILE_INFO_IMAGE* pFileInfoImage, FILE_INFO_FRAME* pFileInfoFrame, void* pUserParam);
PLAYSDK_API BOOL CALLMETHOD	PLAY_SetFileInfoFrameCallback(LONG nPort, fOnFileInfoFrame fFileInfoFrame, tPicFormats imageType, void* pUserParam);

//------------------------------------------------------------------------
// : PLAYER_SetAnalyzePositionCallback
// : ļϢ֡Ȼص
// : 
// : 
//------------------------------------------------------------------------
typedef int (CALLBACK *fOnAnalyzePosition)(LONG nPort, DATETIME_INFO* pstDateTime, void* pUserParam);
PLAYSDK_API BOOL CALLMETHOD	PLAY_SetAnalyzePositionCallback(LONG nPort, fOnAnalyzePosition fAnalyzePosition, void* pUserParam);

//------------------------------------------------------------------------
// : PLAYER_StartFileFrameDetect
// : Ҫ֮󣬿ʼļϢ֡⣬
// : 
// : 
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD	PLAY_StartFileFrameDetect(LONG nPort, FILE_INFO_FRAME_SEARCH* pFileInfoFrameSearch);

//------------------------------------------------------------------------
// : PLAYER_StopFileFrameDetect
// : ֹ
// : 
// : 
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD	PLAY_StopFileFrameDetect(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_StartEdgeEnhance
// : ͼ񻯴
// : level	   -- ȼ,0-ر,6-ǿ,Ĭϵȼ4
//		 algMode   -- 㷨ģʽ,Ԥӿ,Ŀǰֻ֧0
// : TRUE ɹ FALSE ʧ
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_StartEdgeEnhance(LONG nPort, int level, int algMode);

//------------------------------------------------------------------------
// : PLAY_StopEdgeEnhance
// : رͼ񻯴
// : TRUE ɹ FALSE ʧ
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_StopEdgeEnhance(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_StartVideoStable
// : Ƶ
// : TRUE ɹ FALSE ʧ
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_StartVideoStable(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_StopEdgeEnhance
// : رƵ
// : TRUE ɹ FALSE ʧ
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_StopVideoStable(LONG nPort);

//------------------------------------------------------------------------
// : PLAY_Scale
// : ֻ汾ͼ
// : nPort  ˿ں
//       scale	ű[1.0, 8.0]
//       nRegionNum,ʾ, 
// : TRUE ɹ FALSE ʧ
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_Scale(LONG nPort, float scale, DWORD nRegionNum);

//------------------------------------------------------------------------
// : PLAY_Translate
// : ֻ汾ͼƽ
// : nPort  ˿ں
//       x	xƽֵ꣬
//	     y	yƽֵ꣬
//       nRegionNum,ʾ, 
// : TRUE ɹ FALSE ʧ
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_Translate(LONG nPort, float x, float y, DWORD nRegionNum);

//------------------------------------------------------------------------
// : PLAY_SetIdentity
// : ֻ汾ͼһƽƣŲ
// : nPort  ˿ں
//       nRegionNum,ʾ, 
// : TRUE ɹ FALSE ʧ
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetIdentity(LONG nPort, DWORD nRegionNum);

//------------------------------------------------------------------------
// : PLAY_GetScale
// : ֻ汾ȡǰֵ
// : nPort  ˿ں
//       nRegionNum,ʾ, 
// : TRUE ɹ FALSE ʧ
//------------------------------------------------------------------------
PLAYSDK_API float CALLMETHOD PLAY_GetScale(LONG nPort, DWORD nRegionNum);

//------------------------------------------------------------------------
// : PLAY_GetTranslateX
// : ֻ汾ȡǰxƽꡣ
// : nPort  ˿ں
//       nRegionNum,ʾ, 
// : TRUE ɹ FALSE ʧ
//------------------------------------------------------------------------
PLAYSDK_API float CALLMETHOD PLAY_GetTranslateX(LONG nPort, DWORD nRegionNum);

//------------------------------------------------------------------------
// : PLAY_GetTranslateX
// : ֻ汾ȡǰyƽꡣ
// : nPort  ˿ں
//       nRegionNum,ʾ, 
// : TRUE ɹ FALSE ʧ
//------------------------------------------------------------------------
PLAYSDK_API float CALLMETHOD PLAY_GetTranslateY(LONG nPort, DWORD nRegionNum);

//------------------------------------------------------------------------
// : PLAY_CleanScreen
// : ֻ汾
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_CleanScreen(LONG nPort, float red, float green, float blue, float alpha, DWORD nRegionNum);

//------------------------------------------------------------------------
// : PLAY_ViewResolutionChanged
// : Android汾,SurfaceViewС仯ʱ
// : TRUE ɹ FALSE ʧ
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_ViewResolutionChanged(LONG nPort, int nWidth, int nHeight, DWORD nRegionNum);

//------------------------------------------------------------------------
// : PLAY_StartDataRecordEx
// : ʼ¼,ֻģʽ,PLAY_Play֮.
// : nPort,ͨ
//		 sFileName,¼ļ,ļвڵļ,ʹļ.
//		 idataType,0ʾԭʼƵ;1ʾתAVIʽ;2ʾתASFʽ;3ֶαļ
//		 fListenter, صдз.
// : BOOL,ɹTRUE,ʧܷFALSE.
//------------------------------------------------------------------------
typedef void (CALLBACK* fRecordErrorOccur)(LONG nPort, void* pUserData);
PLAYSDK_API BOOL CALLMETHOD PLAY_StartDataRecordEx(LONG nPort, char *sFileName, int idataType, fRecordErrorOccur fListenter, void* pUserData);

//------------------------------------------------------------------------
// : PLAY_SetMultiFrameDecCallBack
// : ϢصSVACеЩϢ
// : nPort  ˿ں
//       nRegionNum,ʾ, 
//		 DecInfoCallBack, ص
//		 pUser, ûص
// : TRUE ɹ FALSE ʧ
//------------------------------------------------------------------------
typedef void (CALLBACK* fMultiFrameDecCallBack)(LONG nPort, LONG nStreamID, char* pData, LONG nLen, 
										  FRAME_INFO* stFrameInfo, void* pUserData, LONG nReserved1);
PLAYSDK_API BOOL CALLMETHOD PLAY_SetMultiFrameDecCallBack(LONG nPort, fMultiFrameDecCallBack DecInfoCallBack, void* pUser);

//------------------------------------------------------------------------
// : PLAY_SetMultiFrameCallBack
// : ֡ϢصĿǰҪSVAC룬
//       SVCУһݴлǿ
// : nPort  ˿ں
//       MultiFrameCallBack, ص
//       pUser  û
// : TRUE ɹ FALSE ʧ
//------------------------------------------------------------------------
typedef void (CALLBACK* fMultiFrameCallBack)(LONG nPort, LONG nStreamID, void* pUserData, LONG nReserved);
PLAYSDK_API BOOL CALLMETHOD PLAY_SetMultiFrameCallBack(LONG nPort, fMultiFrameCallBack MultiFrameCallBack, void* pUser);

//------------------------------------------------------------------------
// : PLAY_SetDecInfoCallBack
// : ֡ϢصSVAC
// : nPort  ˿ں
//       nFrameID, ѡвŵ֡
// : TRUE ɹ FALSE ʧ
//------------------------------------------------------------------------
typedef void (CALLBACK* fDecInfoCallBack)(LONG nPort, FRAME_DEC_EXT_INFO* pDecInfo, void* pUserData, LONG nReserved);
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDecInfoCallBack(LONG nPort, fDecInfoCallBack DecInfoCallBack, void* pUserData);

//------------------------------------------------------------------------
// : PLAY_ChooseFrame
// : ѡʾSVACSVCĻǿ
// : nPort  ˿ں
//       nFrameID, ҪʾĲ(0: 㣬1: ǿ)
// : TRUE ɹ FALSE ʧ
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_ChooseFrame(LONG nPort, LONG nFrameID);

//------------------------------------------------------------------------
// : PLAY_RenderPrivateData
// : ʾ˽ݣ򣬹򱨾ƶ
// : nPort  ˿ں
//       bTrue TRUE: FALSE:ر
// : TRUE ɹ FALSE ʧ
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_RenderPrivateData(LONG nPort, BOOL bTrue, LONG nReserve);

//------------------------------------------------------------------------
// : PLAY_SetFileIndexProgressCallBack
// : Ȼص
// : nPort  ˿ں
// : TRUE ɹ FALSE ʧ
//------------------------------------------------------------------------
typedef void (CALLBACK* fIndexProgressCB)(LONG nPort, float fProgress, void* pUserData);
PLAYSDK_API BOOL CALLMETHOD PLAY_SetFileIndexProgressCallBack(LONG nPort, fIndexProgressCB IndexProgressCB, void* pUser);

//------------------------------------------------------------------------
// : PLAY_GetLastYUVFrame
// : ȡһ֡ӦYUV
// : nPort  ˿ں
// : TRUE ɹ FALSE ʧ
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_GetLastYUVFrame(LONG nPort, FRAME_DECODE_INFO* pFrameDecodeInfo);

//IOSҪڴС汾
PLAYSDK_API BOOL CALLMETHOD PLAY_SetMemMinimized(LONG nPort);

PLAYSDK_API BOOL CALLMETHOD PLAY_SetDecodeThreadNum(LONG nPort, DWORD nNum);

//ýԿSVACʹ
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDecodeKey(LONG nPort, const unsigned char *key, unsigned int key_len);

PLAYSDK_API BOOL CALLMETHOD PLAY_GetIRefValue(LONG nPort, BYTE *pBuffer, DWORD *pSize);

//------------------------------------------------------------------------
// : PLAY_OutsideRender
// : nacl ui̵߳ô˽ӿ
// : nPort  ˿ں
// : nWidth  ڿ
// : nHeight  ڸ
// : TRUE ɹ FALSE ʧ
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_OutsideRender(LONG nPort, int nX, int nY, int nWidth, int nHeight);

namespace pp
{
	class InstanceHandle;
}
//------------------------------------------------------------------------
// : PLAY_SetAudioRender
// : nacl ̵߳ô˽ӿȾ
// : handle  pp::instanceַ
// : TRUE ɹ FALSE ʧ
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SetAudioRender(LONG nPort, const pp::InstanceHandle &handle);

typedef void (CALLBACK* fDoubleVisibleDecCBFun)(LONG nPort,char * pBuf, int nSize, int nWidth, int nHeight, 
												char* pSecondBuf, int nSecondSize, int nSecondWidth, int nSecondHeight, void* pUserData);
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDoubleVisibleDecCallBack(LONG nPort, fDoubleVisibleDecCBFun DataCBFun, void* pUserData);

//------------------------------------------------------------------------
// : PLAY_EnableAudioChannel
// : ƵţƵЧ
// : nPort  ˿ں
// : nChnNum  ͨ0-ͨ1-ͨ
// : bEnable  ʹ TRUE-ã FALSE-
// : TRUE ɹ FALSE ʧ
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_EnableAudioChannel(LONG nPort, DWORD nChnNum, BOOL bEnable);

//------------------------------------------------------------------------
// : PLAY_SplitProc
// : yuv ƴ㷨4kʾ
// : nPort  ˿ں
// : nMode ģʽ0Ӧģʽ1Ӧ1+3ģʽ2Ӧ1+5ģʽ
// : TRUE ɹ FALSE ʧ
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SplitProc(LONG nPort, int nMode);

//------------------------------------------------------------------------
// : PLAY_SplitProcUpdate
// : yuv ƴ㷨ҪŴľλ
// : nPort  ˿ں
// : pAreaRect ʼַ
//       nMode0ӦΪNULL
//       nMode1ĴСӦΪ3
//       nMode2ĴСӦΪ5              | 
// : TRUE ɹ FALSE ʧ
//------------------------------------------------------------------------
PLAYSDK_API BOOL CALLMETHOD PLAY_SplitProcUpdate(LONG nPort, DISPLAYRECT* pAreaRect);

/************************************************************************/
/* : PLAY_SetRenderMode
   : ָȾģʽ(Windowsƽ̨), PLAY_Play֮ǰЧ
   : nPort,ͨ
	     nMode, Ⱦģʽ
   : BOOL,ɹTRUE,ʧܷFALSE.                                                                     */
/************************************************************************/
PLAYSDK_API BOOL CALLMETHOD PLAY_SetRenderMode(LONG nPort, RenderType nMode);

#ifdef	__cplusplus
}
#endif

#endif
