// ChangePassword.cpp : implementation file
//

#include "stdafx.h"
#include "searchdevice.h"
#include "ChangePassword.h"
#include "LibQREncode/qrencode.h"
#include <iostream>


#pragma warning(disable:4291)
#ifndef NEW
#define NEW new(std::nothrow)
#endif

#define QR_PICTURE_PATH "./QRpicture/QRCode.bmp"
/////////////////////////////////////////////////////////////////////////////
// CChangePassword dialog


CChangePassword::CChangePassword(CWnd* pParent /*=NULL*/)
	: CDialog(CChangePassword::IDD, pParent)
{
	//{{AFX_DATA_INIT(CChangePassword)
	m_strSecuityCode = _T("");
	m_strNewPwd = _T("");
	m_strConfirmPwd = _T("");
	//}}AFX_DATA_INIT

	memset(m_cQrCode, 0, MAX_QRCODE_LEN);
	m_showPicture = NULL;

	m_showPicture = NEW CShowPicture();
	if(m_showPicture == NULL)
		return;
    strncpy(m_fileName, QR_PICTURE_PATH, sizeof(m_fileName) - 1);
}


void CChangePassword::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChangePassword)
	DDX_Text(pDX, IDC_EDIT_SECUTITYCODE, m_strSecuityCode);
	DDX_Text(pDX, IDC_EDIT_NEWPWD, m_strNewPwd);
	DDX_Text(pDX, IDC_EDIT_CONFIRMPWD, m_strConfirmPwd);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CChangePassword, CDialog)
	//{{AFX_MSG_MAP(CChangePassword)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChangePassword message handlers

void CChangePassword::OnOK() 
{
	// TODO: Add extra validation here
	UpdateData(TRUE);
	if (m_strSecuityCode.IsEmpty())
	{
		MessageBox(ConvertString("Please input security code"), ConvertString("Prompt"));
		return;
	}
    
    if (m_strNewPwd.IsEmpty())
    {
        MessageBox(ConvertString("Please input password"), ConvertString("Prompt"));
        return ;
    }
    if (m_strConfirmPwd.IsEmpty())
	{
		MessageBox(ConvertString("Plase confirm password"), ConvertString("Prompt"));
		return ;
	}
	if(m_strNewPwd.Compare(m_strConfirmPwd))
	{
		MessageBox(ConvertString("Confirm password is wrongplease input again"),ConvertString("Prompt"));
		return ;
	}

	CDialog::OnOK();
}


//Create bmp picture 
bool CChangePassword::MyQRGenerator(char *szSourceSring)
{
    if (NULL == szSourceSring)
    {
        return false;
    }

	unsigned int unWidth;
	unsigned int unWidthAdjusted;
	unsigned int unDataBytes;
	unsigned char* pRGBData;
	unsigned char* pSourceData;
	unsigned char* pDestData;
	QRcode*		pQRC = NULL;
	FILE*		outFile = NULL;

	pQRC = QRcode_encodeString(szSourceSring, 0, QR_ECLEVEL_H, QR_MODE_8, 1);
	if(0 == pQRC)
	{
		return false;
	}
	
	unWidth = pQRC->width;
	unWidthAdjusted = unWidth * OUT_FILE_PIXEL_PRESCALER * 3;
	if (unWidthAdjusted % 4)
	{
		unWidthAdjusted = (unWidthAdjusted / 4 + 1) * 4;
	}
	unDataBytes = unWidthAdjusted * unWidth * OUT_FILE_PIXEL_PRESCALER;

	// Allocate pixels buffer
	if (!(pRGBData = NEW unsigned char[unDataBytes]))
	{
		return false;
	}

	// Preset to white
	memset(pRGBData, 0xff, unDataBytes);

	// Prepare bmp headers
	BITMAPFILEHEADER kFileHeader;
	kFileHeader.bfType = 0x4d42;  // "BM"
	kFileHeader.bfSize =	sizeof(BITMAPFILEHEADER) +sizeof(BITMAPINFOHEADER) +unDataBytes;
	kFileHeader.bfReserved1 = 0;
	kFileHeader.bfReserved2 = 0;
	kFileHeader.bfOffBits =	sizeof(BITMAPFILEHEADER) +sizeof(BITMAPINFOHEADER);
	BITMAPINFOHEADER kInfoHeader;
	kInfoHeader.biSize = sizeof(BITMAPINFOHEADER);
	kInfoHeader.biWidth = unWidth * OUT_FILE_PIXEL_PRESCALER;
	kInfoHeader.biHeight = -((int)unWidth * OUT_FILE_PIXEL_PRESCALER);
	kInfoHeader.biPlanes = 1;
	kInfoHeader.biBitCount = 24;
	kInfoHeader.biCompression = BI_RGB;
	kInfoHeader.biSizeImage = 0;
	kInfoHeader.biXPelsPerMeter = 0;
	kInfoHeader.biYPelsPerMeter = 0;
	kInfoHeader.biClrUsed = 0;
	kInfoHeader.biClrImportant = 0;

	// Convert QrCode bits to bmp pixels
	pSourceData = pQRC->data;
	int i, j, k, l;
	for(i = 0; i < unWidth; i++)
	{
		pDestData = pRGBData + unWidthAdjusted * i * OUT_FILE_PIXEL_PRESCALER;
		for(j = 0; j < unWidth; j++)
		{
			if (*pSourceData & 1)
			{
				for(k = 0; k < OUT_FILE_PIXEL_PRESCALER; k++)
				{
					for(l = 0; l < OUT_FILE_PIXEL_PRESCALER; l++)
					{
						*(pDestData + l * 3 + unWidthAdjusted * k) = PIXEL_COLOR_B;
						*(pDestData + 1 + l * 3 + unWidthAdjusted * k) = PIXEL_COLOR_G;
						*(pDestData + 2 + l * 3 + unWidthAdjusted * k) = PIXEL_COLOR_R;
					}
				}
			}
			pDestData += 3 * OUT_FILE_PIXEL_PRESCALER;
			pSourceData++;
		}
	}


	// Output the bmp file
	outFile=fopen(m_fileName, "wb");
	if(NULL == outFile)
	{
		delete[] pRGBData;
		return false;
	}

	fwrite(&kFileHeader, sizeof(BITMAPFILEHEADER), 1, outFile);
	fwrite(&kInfoHeader, sizeof(BITMAPINFOHEADER), 1, outFile);
	fwrite(pRGBData, sizeof(unsigned char), unDataBytes, outFile);
	fclose(outFile);

	delete []pRGBData;
	pRGBData = NULL;
	QRcode_free(pQRC);

    return true;
}

BOOL CChangePassword::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// TODO: Add extra initialization here	
    g_SetWndStaticText(this);

	// жϹĿ¼Ƿ QR_PICTURE_PATH е QRpicture Ŀ¼ڣ򴴽
	WIN32_FIND_DATA wfd;
	char szQrDir[] = "./QRpicture";
	HANDLE hFind = FindFirstFile(szQrDir, &wfd);
	if (INVALID_HANDLE_VALUE == hFind)
	{
		// ڸ··
		BOOL bRet = CreateDirectory(szQrDir, NULL);
		if (FALSE == bRet)
		{
			MessageBox(ConvertString("Fail to create QR Directory"),ConvertString("Prompt"));
		}
	}

    ShowQrCode();
	return TRUE;
}

void CChangePassword::OnCancel() 
{
	// TODO: Add extra cleanup here
	CDialog::OnCancel();
}

BOOL CChangePassword::DestroyWindow() 
{
	// TODO: Add your specialized code here and/or call the base class

	if(m_showPicture != NULL)
	{
		delete m_showPicture;
		m_showPicture = NULL;
	}
	
	return CDialog::DestroyWindow();
}

void CChangePassword::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	m_showPicture->RepaintPictures();
}


int CChangePassword::ShowQrCode()
{
    bool bRet = MyQRGenerator(m_cQrCode);
    if (false == bRet)
    {
        MessageBox(ConvertString("Fail to create QRcode"),ConvertString("Prompt"));
        return -1;
    }
    
    HWND pictureHwd = GetDlgItem(IDC_STATIC_QR)->GetSafeHwnd();
    if (NULL == pictureHwd)
    {
        return -1;
    }
	m_showPicture->AddPicture(pictureHwd, m_fileName,0,0);
    return  0;
}
